/**
 * @file
 *
 * @date 25.03.2010
 * @author Alexander Batyukov
 */

#include <asm/head.h>

	.text
	.align 0x1000
.global __test_trap_table
__test_trap_table:
/* Reserved by SPARC architecture traps */
b start; nop; nop; nop;  ! 00 reset trap
TEST_HARD_TRAP;          ! 01
TEST_HARD_TRAP;          ! 02
TEST_HARD_TRAP;          ! 03
TEST_HARD_TRAP;          ! 04
WOF_TRAP;                ! 05 window_overflow
WUF_TRAP;                ! 06 window_underflow
TEST_HARD_TRAP;          ! 07
TEST_HARD_TRAP;          ! 08
TEST_HARD_TRAP;          ! 09
TEST_HARD_TRAP;          ! 0A
TEST_HARD_TRAP;          ! 0B
TEST_HARD_TRAP;          ! 0C
TEST_HARD_TRAP;          ! 0D
TEST_HARD_TRAP;          ! 0E
TEST_HARD_TRAP;          ! 0F
TEST_HARD_TRAP;          ! 10

/* Interrupt entries */
TRAP_ENTRY_INTERRUPT(0x1);         ! 11 interrupt level  1 - IRQ_AHB_error
TRAP_ENTRY_INTERRUPT(0x2);         ! 12 interrupt level  2 - IRQ_UART2
TRAP_ENTRY_INTERRUPT(0x3);         ! 13 interrupt level  3 - IRQ_UART1
TRAP_ENTRY_INTERRUPT(0x4);         ! 14 interrupt level  4
TRAP_ENTRY_INTERRUPT(0x5);         ! 15 interrupt level  5
TRAP_ENTRY_INTERRUPT(0x6);         ! 16 interrupt level  6
TRAP_ENTRY_INTERRUPT(0x7);         ! 17 interrupt level  7
TRAP_ENTRY_INTERRUPT(0x8);         ! 18 interrupt level  8 - IRQ_Timer1
TRAP_ENTRY_INTERRUPT(0x9);         ! 19 interrupt level  9 - IRQ_Timer2
TRAP_ENTRY_INTERRUPT(0xa);         ! 1A interrupt level 10
TRAP_ENTRY_INTERRUPT(0xb);         ! 1B interrupt level 11 - IRQ_DSU
TRAP_ENTRY_INTERRUPT(0xc);         ! 1C interrupt level 12
TRAP_ENTRY_INTERRUPT(0xd);         ! 1D interrupt level 13
TRAP_ENTRY_INTERRUPT(0xe);         ! 1E interrupt level 14 - IRQ_PCI
BAD_TRAP;                          ! 1F interrupt level 15 - IRQ_Halt (NMI)

/* Hardware traps. */

TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 20 - 23 undefined
TEST_HARD_TRAP;                                                 ! 24 cp_disabled
		TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 25 - 27 undefined
TEST_HARD_TRAP;                                                 ! 28 cp_exception
		TEST_HARD_TRAP;                                 ! 29 undefined
				TEST_HARD_TRAP;                 ! 2A division_by_zero
						TEST_HARD_TRAP; ! 2B data_store_error
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 2C - 2F undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 30 - 33 undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 34 - 37 undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 38 - 3B undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 3C - 3F undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 40 - 43 undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 44 - 47 undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 48 - 4B undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 4C - 4F undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 50 - 53 undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 54 - 57 undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 58 - 5B undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 5C - 5F undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 60 - 63 undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 64 - 67 undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 68 - 6B undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 6C - 6F undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 70 - 73 undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 74 - 77 undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 78 - 7B undefined
TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; TEST_HARD_TRAP; ! 7C - 7F undefined

/* Software traps */
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! 80 - 83
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! 84 - 87
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! 88 - 8B
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! 8C - 8F
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! 90 - 93
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! 94 - 97
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! 98 - 9B
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! 9C - 9F
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! A0 - A3
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! A4 - A7
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! A8 - AB
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! AC - AF
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! B0 - B3
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! B4 - B7
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! B8 - BB
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! BC - BF
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! C0 - C3
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! C4 - C7
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! C8 - CB
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! CC - CF
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! D0 - D3
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! D4 - D7
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! D8 - DB
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! DC - DF
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! E0 - E3
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! E4 - E7
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! E8 - EB
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! EC - EF
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! F0 - F3
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! F4 - F7
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! F8 - FB
TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  TEST_SOFT_TRAP;  ! FC - FF
